// Package dvcs (distributed version control system) provides a set of methods that combine go-git and go-gitlab.  It also provides separate constructors for a local Git client and a remote Gitlab client.
package dvcs

import (
	"context"
	"errors"
	"fmt"
	"github.com/go-git/go-billy/v5/memfs"
	"github.com/go-git/go-billy/v5/osfs"
	"github.com/go-git/go-git/v5"
	"github.com/go-git/go-git/v5/config"
	"github.com/go-git/go-git/v5/plumbing"
	"github.com/go-git/go-git/v5/plumbing/cache"
	"github.com/go-git/go-git/v5/plumbing/object"
	"github.com/go-git/go-git/v5/plumbing/transport/http"
	"github.com/go-git/go-git/v5/storage/filesystem"
	"github.com/go-git/go-git/v5/storage/memory"
	"github.com/liturgiko/doxa/pkg/doxlog"
	"github.com/liturgiko/doxa/pkg/enums/gitStatuses"
	"github.com/liturgiko/doxa/pkg/enums/repositoryTypes"
	"github.com/liturgiko/doxa/pkg/license"
	"github.com/liturgiko/doxa/pkg/readme"
	"github.com/liturgiko/doxa/pkg/utils/ltfile"
	"github.com/xanzy/go-gitlab"
	"io/ioutil"
	goHttp "net/http"
	"net/url"
	"os"
	"path"
	"path/filepath"
	"runtime"
	"sort"
	"strings"
	"sync"
	"time"
)

const BaseUrl = "https://gitlab.com"
const BaseApiUrl = "https://gitlab.com/api/v4"
const Username = "doxaUser" // we use tokens, but with go-git, Username must have some value, so we use this.
const Master = "main"
const DefaultOrigin = "origin"
const DoxaOrigin = "doxa-origin"

// SubGroup constants
// if a new group constant is created, also add it to SubGroupNames below and provide a description in SubGroupDesc....

const SubGroupResources = "resources"
const SubGroupResourcesBtx = "btx"
const SubGroupResourcesConfigs = "configs"
const SubGroupResourcesLtx = "ltx"
const SubGroupResourcesMedia = "media"
const SubGroupWebsites = "websites"
const ProjectAssets = "assets"
const ProjectCatalog = "catalog"
const ProjectSubscriptions = "subscriptions"
const ProjectTemplates = "templates"
const ProjectWebsitePublic = "public"
const ProjectWebsiteTest = "test"
const VisibilityPublic = "public"
const Websites = "websites"

type SubGroup struct {
	Name string
	Desc string
}

// UrlSplitters is used by DirPath to decide where to split a URL
var UrlSplitters = []string{
	ProjectAssets,
	ProjectCatalog,
	ProjectSubscriptions,
	ProjectTemplates,
	SubGroupResources,
	SubGroupWebsites,
}

// SubGroups are the top-level subgroups in the root group
var SubGroups = []SubGroup{
	{Name: SubGroupResources, Desc: "projects that can be loaded into a Doxa database"},
	{Name: SubGroupWebsites, Desc: "projects that contain liturgical websites generated by doxa"},
}
var ResourceGroups = []SubGroup{
	{Name: SubGroupResourcesBtx, Desc: "biblical texts that can be loaded into a Doxa database"},
	{Name: SubGroupResourcesConfigs, Desc: "configurations that can be loaded into a Doxa database"},
	{Name: SubGroupResourcesLtx, Desc: "liturgical texts that can be loaded into a Doxa database"},
	{Name: SubGroupResourcesMedia, Desc: "media maps that can be loaded into a Doxa database"},
}

type RemoteProject struct {
	GroupName string
	Name      string
	Desc      string
}

// RemoteProjects provides info to create each required project.
// If GroupName == "", it means, create the project in the Group Root.
var RemoteProjects = []RemoteProject{
	{GroupName: "", Name: ProjectAssets, Desc: "css, js, etc, used by a generated liturgical website"},
	{GroupName: "", Name: ProjectCatalog, Desc: "catalog of resources available to the public to use in their own Doxa projects."},
	{GroupName: "", Name: ProjectTemplates, Desc: "templates that can be used by Doxa to generate books or services"},
	{GroupName: SubGroupWebsites, Name: ProjectWebsitePublic, Desc: "website files generated by Doxa for viewing by the public"},
	{GroupName: SubGroupWebsites, Name: ProjectWebsiteTest, Desc: "website files generated by Doxa for testing"},
}

type LocalGroupPaths struct {
	Projects      string
	Assets        string
	Catalog       string
	Resources     string
	Templates     string
	WebsitePublic string
	WebsiteTest   string
}
type LocalSubscriptionGroupPaths struct {
	Resources string
	Templates string
}

func NewLocalGroupPaths(groupPath string) (*LocalGroupPaths, error) {
	if len(groupPath) == 0 {
		return nil, fmt.Errorf("missing groupPath")
	}
	l := new(LocalGroupPaths)
	l.Projects = path.Dir(groupPath)
	l.Assets = path.Join(groupPath, ProjectAssets)
	l.Catalog = path.Join(groupPath, ProjectCatalog)
	l.Resources = path.Join(groupPath, SubGroupResources)
	l.Templates = path.Join(groupPath, ProjectTemplates)
	l.WebsitePublic = path.Join(groupPath, Websites, ProjectWebsitePublic)
	l.WebsiteTest = path.Join(groupPath, Websites, ProjectWebsiteTest)
	return l, nil
}
func NewLocalSubscriptionGroupPaths(subscriptionsPath, groupPath string) (*LocalSubscriptionGroupPaths, error) {
	if len(subscriptionsPath) == 0 {
		return nil, fmt.Errorf("missing subscriptionsPath")
	}
	if len(groupPath) == 0 {
		return nil, fmt.Errorf("missing groupPath")
	}
	l := new(LocalSubscriptionGroupPaths)
	l.Resources = path.Join(subscriptionsPath, groupPath, SubGroupResources)
	l.Templates = path.Join(subscriptionsPath, groupPath, ProjectTemplates)
	return l, nil
}

type RequestError struct {
	StatusCode int
	Message    string
}

func (r *RequestError) Error() string {
	return fmt.Sprintf("%d %s", r.StatusCode, r.Message)
}

// DVCS is a convenience wrapper for a local Git client and remote Gitlab client.
type DVCS struct { // TODO: create DVCS methods for all Git and Gitlab methods.  Make Git and Gitlab lower case. Then the user will have a single combined interface
	Git            *Git
	Gitlab         *Gitlab
	LocalGroupPath string
	GitlabApi      string //copied form app
}
type Git struct {
	LocalRepoPath string
}
type Gitlab struct {
	Mu                 *sync.Mutex
	LocalGroupPaths    *LocalGroupPaths
	LocalRepo          *git.Repository
	RemoteToken        string
	RemoteRootGroup    *Group
	RemoteClient       *gitlab.Client
	RemoteSubGroupsMap map[string]*gitlab.Group
	RemoteProjectsMap  map[string]*gitlab.Project
	RemoteCatalog      *gitlab.Project
}
type Group struct {
	ID         int
	Name       string
	FullName   string
	Path       string
	FullPath   string
	WebURL     string
	Visibility string
	CreatedAt  *time.Time
}
type SubGroupsMap struct {
	Mu *sync.Mutex
	m  map[string]*gitlab.Group
}

func NewSubGroupsMap() *SubGroupsMap {
	s := new(SubGroupsMap)
	s.Mu = new(sync.Mutex)
	s.m = make(map[string]*gitlab.Group)
	return s
}
func (sg *SubGroupsMap) Set(key string, value *gitlab.Group) {
	sg.Mu.Lock()
	sg.m[key] = value
	sg.Mu.Unlock()
}
func NewDvcsClientLocalOnly(localRepoPath string, localGroupPath string) (*DVCS, error) {
	d := new(DVCS)
	if len(localRepoPath) == 0 {
		return nil, fmt.Errorf("error: missing localReposPath")
	}
	if len(localGroupPath) == 0 {
		return nil, fmt.Errorf("error: missing localGroupPath")
	}
	d.LocalGroupPath = localGroupPath
	d.Git = NewGitClient(localRepoPath)
	return d, nil
}

// NewDvcsClientWithGitlab returns a DVCS client with both a local Git client and remote Gitlab client.
// localReposPath is the path on the local machine that has the local git repositories
// token is a gitlab Personal Access Token
// rootGroupId is the ID of the Gitlab group in which remote projects (repos) are located.
// This functional automatically calls NewGitClient and NewGitlabClient.
// Use it for a convenience wrapper.  NewGitClient and NewGitlabClient can also be used independently of DVCS.
func NewDvcsClientWithGitlab(localGroupPath,
	localRepoPath,
	token string,
	rootGroupId int,
	gitlabApi string,
	initialize bool) (*DVCS, error) {
	var err error
	d := new(DVCS)
	if len(localRepoPath) == 0 || len(token) == 0 || rootGroupId == 0 {
		return nil, fmt.Errorf("error: missing one or more of required parameters localReposPath, token, rootGroupId")
	}
	d.LocalGroupPath = localGroupPath
	d.Git = NewGitClient(localRepoPath)
	d.Gitlab, err = NewGitlabClient(token, rootGroupId, localGroupPath, gitlabApi, initialize)
	d.GitlabApi = gitlabApi
	if err != nil {
		return nil, err
	}
	return d, nil
}

// NewGitClient returns a client for local git repos.  It is also created automatically when you call NewDvcsClient.
func NewGitClient(localReposPath string) *Git {
	g := new(Git)
	g.LocalRepoPath = localReposPath
	return g
}

// NewGitlabClient returns a gitlab client.  It can be used as is, or to set the Gitlab value for a DVCS client.
// Parameters:
//
//		token is a git lab personal access token.
//		rootGroupId is the gitlab numeric ID for the group the user created to hold the doxa subgroups and projects (aka repos)
//	 reposPath is the path to the local directory in which repos are located.
//
// This function will verify that the token can be used to access the group.
// Missing subgroups will be automatically created.  The subgroups are defined by the SubGroups var in the package.
// If the catalog project is missing in the gitlab group, it will be created.
// When returned, the gitlab client will have all properties set.
func NewGitlabClient(token string,
	rootGroupId int,
	localGroupPath, gitlabBase string,
	initialize bool) (*Gitlab, error) {
	g := new(Gitlab)
	g.Mu = new(sync.Mutex)
	localGroupPaths, err := NewLocalGroupPaths(localGroupPath)
	if err != nil {
		return nil, err
	}
	g.LocalGroupPaths = localGroupPaths
	g.RemoteRootGroup = new(Group)
	g.RemoteToken = token
	g.RemoteRootGroup.ID = rootGroupId
	remoteClient, err := gitlab.NewClient(token, gitlab.WithBaseURL(gitlabBase))
	if err != nil {
		return nil, err
	}
	g.RemoteClient = remoteClient
	if rootGroupId > 0 {
		// get the root group info
		rootGroup, res, err := g.GetGroup(g.RemoteRootGroup.ID)
		if err != nil || res.StatusCode != goHttp.StatusOK {
			if res != nil {
				var msg string
				switch res.StatusCode {
				case 400:
					msg = ""
				case 401:
					msg = "you are not authorized"
				case 404:
					msg = "group not found"
				default:
					msg = fmt.Sprintf("error: %v", err)
				}
				return nil, &RequestError{
					StatusCode: res.StatusCode,
					Message:    msg,
				}
			}
			return nil, fmt.Errorf("error getting group: %v", err)
		}
		g.RemoteRootGroup.FullPath = rootGroup.FullPath
		g.RemoteRootGroup.FullName = rootGroup.FullName
		g.RemoteRootGroup.Name = rootGroup.Name
		g.RemoteRootGroup.Path = rootGroup.Path
		g.RemoteRootGroup.Visibility = string(rootGroup.Visibility)
		g.RemoteRootGroup.WebURL = rootGroup.WebURL
		g.RemoteRootGroup.CreatedAt = rootGroup.CreatedAt
		if initialize {
			go func() {
				err = g.Init()
				if err != nil {

				}
			}()
		}
	}
	// debug: uncomment to write out g
	//indent, _ := json.MarshalIndent(g, "", " ")
	//fmt.Println(string(indent))
	return g, nil
}

// ValidateRepo ensures that the remote exists, creating it if needed
// it also makes sure that local exists, cloning it if not
func (d *DVCS) ValidateRepo(localPath, url, groupName, subgroupPath, repoName, token string) error {
	if d.Gitlab == nil {
		//locate gitlab projects
		//get the gitlab base
		urlChunks := strings.Split(url, groupName)
		if len(urlChunks) < 2 {
			return fmt.Errorf("could not extract gitlab instance from url: '%s' using splitter '%s'", url, groupName)
		}
		gID, err := d.GetProjectGroup(token, groupName, strings.TrimSuffix(url, path.Join(urlChunks[0], strings.TrimPrefix(BaseApiUrl, BaseUrl))))
		if err != nil {
			return err
		}
		d.Gitlab, err = NewGitlabClient(token, gID, localPath, d.GitlabApi, true)
		if err != nil {
			return err
		}
		err = d.Gitlab.populateSubGroupsMap()
		if err != nil {
			return err
		}
		err = d.Gitlab.populateProjectsMap()
		if err != nil {
			return err
		}
	}
	remote, err := d.Gitlab.CreateProject(path.Join(groupName, subgroupPath), repoName, "created by doxa")
	if err != nil {
		return err
	}
	newLocal, err := ltfile.IsEmptyDir(localPath, true)
	err = d.Gitlab.InitLocalRepo(localPath, remote.HTTPURLToRepo)
	if err != nil {
		return err
	}
	if newLocal {
		mrGit := NewGitClient(localPath)
		status, err := mrGit.PullWithAuth(localPath, DoxaOrigin, "doxa", token, true)
		if status != gitStatuses.RemoteEmpty {
			fmt.Sprintf("%s", status.String())
			if !errors.Is(err, git.NoErrAlreadyUpToDate) {
				return err
			}
		}
	}
	return nil
}

func (d *DVCS) GetProjectGroup(token, groupName, base string) (int, error) {
	gl, err := gitlab.NewClient(token, gitlab.WithBaseURL(base))
	if err != nil {
		return 0, err
	}
	opt := &gitlab.ListGroupsOptions{
		Search:       gitlab.String(groupName),
		TopLevelOnly: gitlab.Bool(true),
		ListOptions: gitlab.ListOptions{
			PerPage: 10,
			Page:    1,
		},
	}
	groups, _, err := gl.Groups.ListGroups(opt)
	if err != nil {
		return 0, err
	}
	var groupID int
	for _, group := range groups {
		if group.Name == groupName {
			groupID = group.ID
			break
		}
	}

	if groupID != 0 {
		return groupID, err
	} else {
		return 0, fmt.Errorf("could not find gitlab group")
	}
}

// Init initializes all the expected subgroups and projects for the root group
func (g *Gitlab) Init() error {
	g.Mu.Lock()
	defer g.Mu.Unlock()
	var err error
	var theErrors []error
	// load the subgroup's map.  This will also verify the user's token works
	err = g.populateSubGroupsMap()
	if err != nil {
		theErrors = append(theErrors, err)
	}
	// initialize any missing root subgroups
	err = g.initSubGroups()
	if err != nil {
		theErrors = append(theErrors, err)
	}
	// initialize any missing resources subgroups
	err = g.initResourcesSubGroups()
	if err != nil {
		theErrors = append(theErrors, err)
	}
	var pmMapErrors []error
	// create and populate the ProjectsMap recursively from the root group.
	err = g.populateProjectsMap()
	if err != nil {
		pmMapErrors = append(pmMapErrors, err)
	}
	// create any missing projects
	for _, p := range RemoteProjects {
		projectKey := strings.ToLower(path.Join(p.GroupName, p.Name))
		if _, ok := g.RemoteProjectsMap[projectKey]; !ok {
			remote, _, err := g.CreateRemoteAndLocalProject(p.GroupName, p.Name, p.Desc)
			if err != nil {
				pmMapErrors = append(pmMapErrors, err)
			} else {
				g.RemoteProjectsMap[strings.ToLower(remote.PathWithNamespace)] = remote
			}
		}
	}

	if len(theErrors) > 0 {
		for _, err := range theErrors {
			doxlog.Errorf("error initializing gitlab: %s\n", err)
		}
		return theErrors[0]
	}
	if len(pmMapErrors) > 0 {
		for _, err := range pmMapErrors {
			doxlog.Errorf("error initializing gitlab: %s\n", err)
		}
		return pmMapErrors[0]
	}
	return nil
}
func SshUrlToHttps(sshUrl string) (httpsUrl string, err error) {
	// no conversion if already https
	if strings.HasPrefix(sshUrl, "https") {
		return sshUrl, nil
	}
	from := "git@gitlab.com:"
	if !strings.HasPrefix(sshUrl, from) {
		return "", fmt.Errorf("%s is not a valid ssh url", sshUrl)
	}
	httpsUrl = fmt.Sprintf("https://gitlab.com/%s", sshUrl[len(from):])
	return httpsUrl, nil
}
func (g *Gitlab) populateProjectsMap() error {
	g.RemoteProjectsMap = make(map[string]*gitlab.Project)
	l := &gitlab.ListOptions{
		Page:    1,
		PerPage: 100,
	}
	o := &gitlab.ListGroupProjectsOptions{
		ListOptions:      *l,
		Archived:         gitlab.Bool(false),
		IncludeSubGroups: gitlab.Bool(true),
	}
	for { // the api pages the results, so we keep calling until we have seen all pages
		items, res, err := g.RemoteClient.Groups.ListGroupProjects(g.RemoteRootGroup.ID, o)
		if err != nil {
			return fmt.Errorf(fmt.Sprintf("error reading projects in group %s (%d): %v", g.RemoteRootGroup.WebURL, g.RemoteRootGroup.ID, err))
		}
		if res.StatusCode != goHttp.StatusOK {
			return fmt.Errorf(fmt.Sprintf("error reading projects in group %s (%d): %d %s", g.RemoteRootGroup.WebURL, g.RemoteRootGroup.ID, res.StatusCode, res.Status))
		}
		// Add items to map.
		for _, item := range items {
			// gitlab sometimes returns groups that have been deleted.
			// try retrieving it to see if it is really there.
			// if not, don't add to the map
			_, _, err = g.GetProject(item.ID)
			if err != nil { // don't add to map
				continue
			}
			g.RemoteProjectsMap[strings.ToLower(item.PathWithNamespace)] = item
		}
		// Exit the loop when we've seen all pages.
		if res.CurrentPage >= res.TotalPages {
			break
		}
		// Update the page number to get the next page.
		o.ListOptions.Page = res.NextPage
	}
	return nil
}
func (g *Gitlab) CreateSubGroup(parentId int, name, desc string) (*gitlab.Group, error) {
	o := &gitlab.CreateGroupOptions{
		Name:        gitlab.String(name),
		Path:        gitlab.String(name),
		Description: gitlab.String(desc),
		Visibility:  gitlab.Visibility(VisibilityPublic),
		ParentID:    gitlab.Int(parentId),
	}
	group, res, err := g.RemoteClient.Groups.CreateGroup(o, nil)
	if err != nil {
		if strings.Contains(err.Error(), "has already been taken") {
			//get the already created group
			if _, populated := g.RemoteSubGroupsMap[strings.ToLower(name)]; !populated {
				err = g.populateSubGroupsMap()
				if err != nil {
					return nil, err
				}
				if _, populated = g.RemoteSubGroupsMap[strings.ToLower(name)]; !populated {
					if ret, otherStyle := g.RemoteSubGroupsMap[strings.ToLower(path.Join(g.RemoteRootGroup.Path, name))]; otherStyle {
						return ret, nil
					}
					return nil, fmt.Errorf("could not find '%s' in subgroup map", name)
				}
			}
			return g.RemoteSubGroupsMap[strings.ToLower(name)], nil
		}
		return nil, err
	}
	if res.StatusCode != goHttp.StatusCreated {
		if res.StatusCode == goHttp.StatusBadRequest {
			// Check if the error message indicates that the group already exists
			if strings.Contains(err.Error(), "has already been taken") {
				//get the already created group
				if _, populated := g.RemoteSubGroupsMap[strings.ToLower(name)]; !populated {
					err = g.populateSubGroupsMap()
					if err != nil {
						return nil, err
					}
					if _, populated = g.RemoteSubGroupsMap[strings.ToLower(name)]; !populated {
						return nil, err
					}
				}
				return g.RemoteSubGroupsMap[strings.ToLower(name)], nil
			}
		}
		return nil, fmt.Errorf("error creating subgroup %s in group %d: %v", name, g.RemoteRootGroup.ID, err)
	}
	return group, nil
}
func (g *Gitlab) CreateRemoteAndLocalProject(subGroupName, projectName, desc string) (*gitlab.Project, string, error) {
	var subGroupPath = path.Join(g.RemoteRootGroup.Name, subGroupName)
	remote, err := g.CreateProject(subGroupPath, projectName, desc)
	if err != nil {
		return nil, "", err
	}
	var localPath = path.Join(g.LocalGroupPaths.Projects, g.RemoteRootGroup.Name, subGroupName, projectName)
	err = g.InitLocalRepo(localPath, remote.HTTPURLToRepo)
	if err != nil {
		return nil, "", err
	}
	return remote, localPath, nil
}

// CreateProject creates a new project in the specified subgroup.  If the len(subGroupName) == 0, the client group ID will be used instead.
// A README will not be initialized.
// Email notifications will be enabled.
// If the remote project already exists, it will the project will be returned without an error
func (g *Gitlab) CreateProject(subGroupPath, projectName, desc string) (*gitlab.Project, error) {
	var namespaceId int
	if len(subGroupPath) == 0 || strings.ToLower(subGroupPath) == strings.ToLower(g.RemoteRootGroup.Name) {
		namespaceId = g.RemoteRootGroup.ID
	} else {
		var sg *gitlab.Group
		var ok bool
		if sg, ok = g.RemoteSubGroupsMap[strings.ToLower(subGroupPath)]; !ok {
			return nil, fmt.Errorf(fmt.Sprintf("%s not a subgroup of group %d", subGroupPath, g.RemoteRootGroup.ID))
		}
		namespaceId = sg.ID
	}
	projectPath := strings.ToLower(path.Join(subGroupPath, projectName))
	// return project if already exists
	if p, ok := g.RemoteProjectsMap[projectPath]; ok {
		return p, nil
	}
	o := &gitlab.CreateProjectOptions{
		Name:                 gitlab.String(projectName),
		Description:          gitlab.String(desc),
		EmailsDisabled:       gitlab.Bool(false),
		InitializeWithReadme: gitlab.Bool(false),
		MergeRequestsEnabled: gitlab.Bool(true),
		NamespaceID:          gitlab.Int(namespaceId),
		SnippetsEnabled:      gitlab.Bool(false),
		Visibility:           gitlab.Visibility(gitlab.PublicVisibility),
	}
	project, res, err := g.RemoteClient.Projects.CreateProject(o)
	if err != nil {
		return nil, fmt.Errorf(fmt.Sprintf("error creating project %s: %v", projectName, err))
	}
	if res.StatusCode != goHttp.StatusCreated {
		return nil, fmt.Errorf(fmt.Sprintf("error creating project %s: %d %s", projectName, res.StatusCode, res.Status))
	}
	if !project.Public {
		doxlog.Warnf("the project '%s' was not set to public, attempting manual override", projectName)
	}
	return project, nil
}

// UserHasDeveloperPermissions gid can be group name (string) or group ID (int)
func (g *Gitlab) UserHasDeveloperPermissions(gid interface{}) (bool, error) {
	user, _, err := g.RemoteClient.Users.CurrentUser()
	if err != nil {
		return false, err
	}

	group, _, err := g.RemoteClient.Groups.GetGroup(gid, nil)
	if err != nil {
		return false, err
	}
	member, _, err := g.RemoteClient.GroupMembers.GetGroupMember(group.ID, user.ID, nil)
	if err != nil {
		return false, err
	}

	if member.AccessLevel >= gitlab.DeveloperPermissions {
		return true, nil
	}
	return false, nil
}

// GetGroup by passing in either the group name (string) or its group ID (int)
func (g *Gitlab) GetGroup(gid interface{}) (*Group, *gitlab.Response, error) {
	gitlabGroup, r, err := g.RemoteClient.Groups.GetGroup(gid, nil, nil)
	if err != nil {
		return nil, nil, err
	}
	group := new(Group)
	group.CreatedAt = gitlabGroup.CreatedAt
	group.FullName = gitlabGroup.FullName
	group.FullPath = gitlabGroup.FullPath
	group.ID = gitlabGroup.ID
	group.Name = gitlabGroup.Name
	group.Path = gitlabGroup.Path
	group.Visibility = string(gitlabGroup.Visibility)
	group.WebURL = gitlabGroup.WebURL
	return group, r, nil
}

// GetProject gets a specific project (aka repository, not doxa project group),
// identified by project ID or NAMESPACE/PROJECT_NAME,
// which is owned by the authenticated user.
func (g *Gitlab) GetProject(pid interface{}) (*gitlab.Project, *gitlab.Response, error) {
	return g.RemoteClient.Projects.GetProject(pid, nil, nil)
}
func NormalizeUrlForApi(theUrl string) string {
	theUrl = strings.TrimPrefix(theUrl, "https://gitlab.com/")
	return strings.TrimSuffix(theUrl, ".git")
}

// populateSubGroupsMap creates and populates the client subgroups map with the groups required by doxa
func (g *Gitlab) populateSubGroupsMap() error {
	g.RemoteSubGroupsMap = make(map[string]*gitlab.Group)
	groups, res, err := g.RemoteClient.Groups.ListDescendantGroups(g.RemoteRootGroup.ID, nil)
	if err != nil {
		return err
	}
	if res.StatusCode != goHttp.StatusOK {
		return fmt.Errorf(fmt.Sprintf("%d: %s", res.StatusCode, res.Status))
	}
	for _, group := range groups {
		// gitlab sometimes returns groups that have been deleted.
		// try retrieving it to see if it is really there.
		// if not, don't add to the map
		_, _, err = g.GetGroup(group.ID)
		if err != nil { // don't add to map
			continue
		}
		g.RemoteSubGroupsMap[strings.ToLower(group.FullPath)] = group
	}
	return nil
}
func (g *Gitlab) isDoxaSubGroup(name string) bool {
	for _, group := range SubGroups {
		if group.Name == name {
			return true
		}
	}
	return false
}

// initResourceSubGroups initializes any missing subgroup defined by ResourceGroups
func (g *Gitlab) initResourcesSubGroups() error {
	var parentGroup *gitlab.Group
	var ok bool
	parentGroupKey := fmt.Sprintf("%s/%s", g.RemoteRootGroup.Name, SubGroupResources)
	if parentGroup, ok = g.RemoteSubGroupsMap[strings.ToLower(parentGroupKey)]; !ok {
		return fmt.Errorf(fmt.Sprintf("subgroup %s not in subgroup map", SubGroupResources))
	}
	parentId := parentGroup.ID
	// check for each expected subgroup.  Create any that are missing
	for _, group := range ResourceGroups {
		groupKey := fmt.Sprintf("%s/%s", parentGroup.FullPath, group.Name)
		if _, ok = g.RemoteSubGroupsMap[strings.ToLower(groupKey)]; !ok {
			subGroup, err := g.CreateSubGroup(parentId, group.Name, group.Desc)
			if err != nil {
				return fmt.Errorf(fmt.Sprintf("error creating subgroup %s in resourses group %d: %v", group.Name, parentId, err))
			}
			g.RemoteSubGroupsMap[strings.ToLower(groupKey)] = subGroup
		}
	}
	return nil
}

// initSubGroups initializes any missing subgroup defined by SubGroups
func (g *Gitlab) initSubGroups() error {
	if g.RemoteRootGroup == nil {
		doxlog.Errorf("could not initialize subgroups, top-level group is nil")
		return fmt.Errorf("remote root group is nil")
	}
	// check for each expected subgroup.  Create any that are missing
	for _, group := range SubGroups {
		groupKey := fmt.Sprintf("%s/%s", g.RemoteRootGroup.Name, group.Name)
		if _, ok := g.RemoteSubGroupsMap[strings.ToLower(groupKey)]; !ok {
			subGroup, err := g.CreateSubGroup(g.RemoteRootGroup.ID, group.Name, group.Desc)
			if err != nil {
				return err
			}
			g.RemoteSubGroupsMap[strings.ToLower(subGroup.FullPath)] = subGroup
		}
	}
	return nil
}

// InitLocalRepo will initialize git in the dirPath and set the remote to the specified url.
// If the dirPath does not exist, it will be created.
func (g *Gitlab) InitLocalRepo(dirPath string, url string) error {
	if !ltfile.DirExists(dirPath) {
		err := ltfile.CreateDirs(dirPath)
		if err != nil {
			return err
		}
	}
	//fs := osfs.New(dirPath)
	//dot, err := fs.Chroot(".git")
	//if err != nil {
	//	return err
	//}
	var r *git.Repository
	// see if repo already exists.  If not, create it.
	_, err := git.PlainOpen(dirPath)
	if err == nil { // repo already exists, but create readme and license if they do not exist
		return nil //g.WriteReadMeAndLicense(dirPath, false)
	}
	// repo does not exist, so initialize it
	//storage := filesystem.NewStorage(dot, cache.NewObjectLRUDefault())
	//r, err = git.Init(storage, nil)
	opts := &git.PlainInitOptions{
		InitOptions: git.InitOptions{
			DefaultBranch: plumbing.ReferenceName("refs/heads/main"),
		},
		Bare: false,
	}
	r, err = git.PlainInitWithOptions(dirPath, opts)
	if err != nil {
		return err
	}
	// Add doxa-origin url
	err = g.InitDoxaOrigin(dirPath, url)
	if err != nil {
		return err
	}
	// Add origin url for ssh so use can also push if using git themselves
	var sshUrl string
	sshUrl, err = HttpRepoUrlToSsh(url)
	if err != nil {
		return err
	}
	_, err = r.CreateRemote(&config.RemoteConfig{
		Name: "origin",
		URLs: []string{sshUrl},
	})
	if err != nil {
		return err
	}
	// create the master branch
	err = r.CreateBranch(&config.Branch{
		Name:   Master,
		Remote: DoxaOrigin,
	})
	if err != nil {
		return err
	}
	//err = g.WriteReadMeAndLicense(dirPath, false)
	//if err != nil {
	//	return err
	//}
	err = g.WriteGitIgnore(dirPath)
	if err != nil {
		return err
	}
	return nil
}

func (g *Gitlab) InitDoxaOrigin(dirPath, url string) error {
	r, err := git.PlainOpen(dirPath)
	if err != nil { // repo does not exist
		return fmt.Errorf("error opening %s: %v", dirPath, err)
	}
	var httpsUrl string
	httpsUrl, err = SshUrlToHttps(url)
	if err != nil {
		return err
	}
	_, err = r.CreateRemote(&config.RemoteConfig{
		Name: DoxaOrigin,
		URLs: []string{httpsUrl},
	})
	return nil
}
func (g *Gitlab) WriteGitIgnore(localPath string) error {
	var onMac = runtime.GOOS == "darwin"
	var ignore string
	if onMac {
		ignore = ".DS_Store\n**/.DS_Store\ndcs/t"
	}
	var content = fmt.Sprintf("%s", ignore)
	gitIgnorePath := path.Join(localPath, ".gitignore")
	return ltfile.WriteFile(gitIgnorePath, content)
}
func (g *Gitlab) WriteReadMeAndLicense(license *license.License, readme *readme.ReadMe, localPath string, overwrite bool) error {
	if license == nil {
		return fmt.Errorf("gitlab license is nil")
	}
	if readme == nil {
		return fmt.Errorf("gitlab readme is nil")
	}
	if !ltfile.DirExists(localPath) {
		return fmt.Errorf("%s does not exist", localPath)
	}
	parts := strings.Split(localPath, g.LocalGroupPaths.Projects)
	if len(parts) == 1 {
		return fmt.Errorf("%s is an invalid path, must be within %s", localPath, g.LocalGroupPaths.Projects)
	}
	parts = strings.Split(parts[1], "/")
	subgroup := path.Base(path.Dir(localPath))
	name := path.Base(localPath)
	if !readme.Exists(localPath) || overwrite {
		readme.Title = fmt.Sprintf("%s %s ", subgroup, name)
		readme.RepositoryType = repositoryTypes.CodeForString(name)
		if readme.RepositoryType == repositoryTypes.Unknown {
			readme.RepositoryType = repositoryTypes.CodeForString(subgroup)
		}
		readme.Description = readme.StandardDesc(readme.RepositoryType)
		if readme.RepositoryType == repositoryTypes.WebSite {
			// prefix public or test to the description
			readme.Description = fmt.Sprintf("%s %s", name, readme.Description)
		}
		err := readme.Write(localPath)
		if err != nil {
			return err
		}
	}
	// initialize a LICENSE file
	if !license.Exists(localPath) || overwrite {
		license.WorkName = fmt.Sprintf("%s %s ", subgroup, name)
		err := license.Write(localPath)
		if err != nil {
			return err
		}
	}
	return nil
}

// HttpRepoUrlToSsh converts an HTTP clone url to an ssh form.
// http format:https://gitlab.com/doxa-mac/resources/btx/en_uk_kjv.git
// ssh format: git@gitlab.com:doxa-mac/resources/btx/en_uk_kjv.git
func HttpRepoUrlToSsh(theUrl string) (string, error) {
	if strings.HasPrefix(theUrl, "git@") {
		return theUrl, nil
	}
	u, err := url.Parse(theUrl)
	if err != nil {
		return theUrl, err
	}
	return fmt.Sprintf("git@%s:%s", u.Host, u.Path[1:]), nil
}
func GroupUrlToClonePathPrefix(groupUrl string) (string, error) {
	if !strings.Contains(groupUrl, "/groups/") {
		return "", fmt.Errorf("%s is not a group web url", groupUrl)
	}
	return strings.Replace(groupUrl, "/groups/", "/", 1), nil
}
func (g *Gitlab) OpenLocalRepo(path string) error {
	var err error
	g.LocalRepo, err = git.PlainOpen(path)
	if err != nil {
		return fmt.Errorf(fmt.Sprintf("error opening repo at %s: %v", path, err))
	}
	return nil
}
func (g *Gitlab) Push() error {
	if g.LocalRepo == nil {
		return fmt.Errorf(fmt.Sprintf("local repo not open"))
	}
	return nil
}

// DirPath converts repository clone url into
// a path into which to clone the repository
func DirPath(parentDir, theUrl string) (result string, err error) {
	Url, err := url.Parse(strings.TrimSpace(theUrl))
	if err != nil {
		return "", err
	}
	chunks := strings.Split(Url.Path, "/")
	for i, dirName := range chunks {
		for _, keyword := range UrlSplitters {
			if strings.HasSuffix(dirName, ".git") {
				dirName = dirName[:len(dirName)-4]
			}
			if keyword == dirName {
				result = path.Join(parentDir, path.Join(chunks[i:]...))
				if strings.HasSuffix(result, ".git") {
					result = result[:len(result)-4]
				}
				return result, nil
			}
		}
	}
	return "", fmt.Errorf("invalid url %s", theUrl)
}

// CloneRepos Clone sequentially each repository to the parent
// directory specified in path.
// The directory will be created by the Clone function.
// Be aware that the contents of the root directory will
// be deleted if it already exists.
func (g *Git) CloneRepos(path string, urls []string, deleteFirst, progress bool, depth int) error {
	_ = ltfile.DeleteDirRecursively(path)
	err := ltfile.CreateDirs(path)
	if err != nil {
		return err
	}
	for _, theUrl := range urls {
		u, err := g.Clone(path, theUrl, deleteFirst, progress, depth)
		fmt.Println(u)
		if err != nil {
			fmt.Println(err)
		}
	}
	return err
}

// CloneConcurrently Clone concurrently each repository to the parent
// directory specified in path.
// The directory will be created by the Clone function.
// Be aware that the contents of the root directory will
// be deleted if it already exists. This func runs nearly
// twice as fast as the CloneRepos func.
//func (g *Git) CloneConcurrently(path string, urls []string, deleteFirst, progress bool, depth int) error {
//	//		// toDir string, repoUrl string, deleteFirst, progress bool, depth int
//	_ = os.RemoveAll(path)
//	err := os.MkdirAll(path, os.ModePerm)
//	if err != nil {
//		return err
//	}
//	done := make(chan string, len(urls))
//	errch := make(chan error, len(urls))
//
//	for _, theUrl := range urls {
//		go func(path, url string) {
//			u, err := g.Clone(path, url, deleteFirst, progress, depth)
//			done <- u
//			errch <- err
//		}(path, theUrl)
//	}
//	for i := 0; i < len(urls); i++ {
//		fmt.Println(<-done)
//		if err := <-errch; err != nil {
//			fmt.Println(err)
//		}
//	}
//	return err
//}

//func (g *Git) Clone(path string, url string, deleteFirst bool) (string, error) {
//	dirPath, err := DirPath(path, url)
//	if err != nil {
//		return url, err
//	}
//	if deleteFirst {
//		err = os.RemoveAll(dirPath)
//		if err != nil {
//			return url, err
//		}
//	}
//	_, err = git.PlainClone(dirPath, false, &git.CloneOptions{
//		URL: url,
//		//		Progress: os.Stdout,
//	})
//	return dirPath, err
//}

// Clone the repo into the dir.
// If deleteFirst == true, an existing repo dir will be deleted, then the clone will occur.
//
//	If you set deleteFirst = false, then the directory that the clone will create should not exist.
//
// If progress == true, the clone process will write to os.Stdout
// If depth > 0, a shallow clone will occur, only downloading depth-1 past commit histories.
//
//	Depending on how many prior commits and pushes have occurred, setting depth = 1 can
//	significantly reduce the time it takes to clone and the amount of local file storage used.
//
// Read git guidelines on when to use shallow clone.  Do not use if subsequent git operations
// require history.
func (g *Git) Clone(toDir string, repoUrl string, deleteFirst, progress bool, depth int) (string, error) {
	dirPath, err := DirPath(toDir, repoUrl)
	if err != nil {
		return repoUrl, err
	}
	if deleteFirst {
		err = ltfile.DeleteDirRecursively(dirPath)
		if err != nil {
			return repoUrl, err
		}
	}
	opt := &git.CloneOptions{}
	opt.URL = repoUrl
	if progress {
		opt.Progress = os.Stdout
	}
	if depth > 0 {
		opt.Depth = depth
	}
	_, err = git.PlainClone(dirPath, false, opt)
	return dirPath, err
}

func (g *Git) CloneWithContext(ctx context.Context, toDir string, repoUrl string, deleteFirst, progress bool, depth int) (string, error) {
	dirPath, err := DirPath(toDir, repoUrl)
	if err != nil {
		return repoUrl, err
	}

	if deleteFirst {
		if err = ltfile.DeleteDirRecursively(dirPath); err != nil {
			return repoUrl, err
		}
	}

	opt := &git.CloneOptions{
		URL:      repoUrl,
		Progress: ioutil.Discard,
		Depth:    depth,
	}

	if progress {
		opt.Progress = os.Stdout
	}

	// Use PlainCloneContext instead of PlainClone
	_, err = git.PlainCloneContext(ctx, dirPath, false, opt)
	return dirPath, err
}

// CloneConcurrently Clone concurrently each repository to the parent
// directory specified in path.
// The directory will be created by the Clone function.
// Be aware that the contents of the root directory will
// be deleted if it already exists. This func runs nearly
// twice as fast as the CloneRepos func.
// See func Clone for parameters after urls.
func (g *Git) CloneConcurrently(ctx context.Context, parentDir string, urls []string, depth int, deleteParentDir, deleteRepDir bool) map[string]error {
	var wg sync.WaitGroup
	errMap := make(map[string]error)
	var mu sync.Mutex // Mutex to protect the errMap

	for _, theUrl := range urls {
		pathUrl, err := url.Parse(theUrl)
		if err != nil {
			doxlog.Errorf("Invalid url '%s'", theUrl)
			mu.Lock()
			errMap[theUrl] = fmt.Errorf("invalid URL: %v", err)
			mu.Unlock()
			continue
		}

		chunks := strings.Split(strings.TrimPrefix(pathUrl.Path, "/"), "/")
		if len(chunks) > 0 {
			parentDir = path.Join(path.Dir(parentDir), chunks[0])
		}

		wg.Add(1)
		go func(rpath, url string) {
			defer wg.Done()

			if deleteParentDir {
				if err := ltfile.DeleteDirRecursively(parentDir); err != nil {
					mu.Lock()
					errMap[url] = fmt.Errorf("failed to remove directory %s: %v", parentDir, err)
					mu.Unlock()
					return
				}
			}

			if err := ltfile.CreateDirs(parentDir); err != nil {
				mu.Lock()
				errMap[url] = fmt.Errorf("failed to create directory %s: %v", parentDir, err)
				mu.Unlock()
				return
			}

			select {
			case <-ctx.Done():
				mu.Lock()
				errMap[url] = ctx.Err()
				mu.Unlock()
				return
			default:
				u, err := g.CloneWithContext(ctx, rpath, url, deleteRepDir, false, depth)
				if err != nil {
					if !errors.Is(err, git.ErrRepositoryAlreadyExists) {
						mu.Lock()
						errMap[url] = fmt.Errorf("error cloning repo %s: %w", url, err)
						mu.Unlock()
						return
					}
					_, err := g.Pull(rpath, DoxaOrigin, true)
					if err != nil {
						if !errors.Is(err, git.NoErrAlreadyUpToDate) {
							mu.Lock()
							errMap[url] = fmt.Errorf("error pulling repo: %w", err)
							mu.Unlock()
							return
						}
					}
				}
				doxlog.Infof("Successfully cloned or updated repo: %s", u)
			}
		}(parentDir, theUrl)
	}

	wg.Wait()

	// Log any errors that occurred
	for url, err := range errMap {
		if errors.Is(err, git.ErrFetching) {
			doxlog.Errorf("Could not fetch %s: %v", url, err)
		} else if errors.Is(err, git.ErrFastForwardMergeNotPossible) {
			doxlog.Errorf("Non-fast-forward update for %s: %v", url, err)
		} else {
			doxlog.Warnf("Error for %s: %v", url, err)
		}
	}

	return errMap
}

// CloneReposWithNotification clones repositories concurrently and returns a channel with successful clone file paths.
// All repos will be cloned into the parentDir.
// If deleteParentDirFirst is true, the parent directory will be deleted before the cloning begins.
// All existing repos in the parent directory will be deleted and replaced.
// During concurrent cloning, some repos will finish cloning before others.
// Use the return channel <-channel string to receive notice of each completed
// clone's filesystem path.  That allows processing to occur as soon as the repo is available.
// If depth is set to 1, no git history will be downloaded.
// This can significantly decrease clone time and space of the cloned repo.
// If removeGitDir is true, after cloning, the .git directory will be deleted from
// the repository.
func (g *Git) CloneReposWithNotification(ctx context.Context, parentDir string, urls []string, deleteParentFirst, removeGitDir bool, depth int) (<-chan string, error) {
	if deleteParentFirst {
		if err := ltfile.DeleteDirRecursively(parentDir); err != nil {
			return nil, fmt.Errorf("failed to remove directory %s: %v", parentDir, err)
		}
	}

	if err := ltfile.CreateDirs(parentDir); err != nil {
		return nil, fmt.Errorf("failed to create directory %s: %v", parentDir, err)
	}

	done := make(chan string, len(urls))
	errChannel := make(chan error, len(urls))

	var wg sync.WaitGroup

	for _, theUrl := range urls {
		select {
		case <-ctx.Done():
			break
		default:
		}
		wg.Add(1)
		go func(cloneToPath, url string) {
			defer wg.Done()
			_ = ltfile.DeleteDirRecursively(cloneToPath)
			u, err := g.Clone(cloneToPath, url, false, false, depth)
			if err != nil {
				errChannel <- fmt.Errorf("error cloning repo %s: %v", url, err)
				return
			}
			//if removeGitDir {
			//	err = ltfile.DeleteDirRecursively(filepath.Join(u, ".git"))
			//	if err != nil {
			//		errChannel <- fmt.Errorf("error deleting .git dir from repo %s: %v", url, err)
			//		return
			//	}
			//}
			done <- u // Send cloned path
		}(parentDir, theUrl)
	}

	// Close the channels when all goroutines are done
	go func() {
		wg.Wait()
		close(done)
		close(errChannel)
	}()

	// Return a channel for errors to be handled separately
	go func() {
		// Collect errors and return them through a separate mechanism if needed
		for err := range errChannel {
			doxlog.Errorf("Error: %v", err)
		}
	}()

	return done, nil
}

type ProcessMessage struct {
	RepoURL string
	Message string
}

type ProcessError struct {
	RepoURL string
	Error   error
}

func (g *Git) CloneAndProcessRepos(
	ctx context.Context,
	cloneURLs []string,
	depth int,
	fileExtension string,
	outputChan chan<- string,
	errorChan chan<- ProcessError,
	messageChan chan<- ProcessMessage,
) {
	defer close(outputChan)
	defer close(errorChan)
	defer close(messageChan)

	//ctx, cancel := context.WithCancel(ctx)
	//defer cancel()

	sendMessage := func(msg ProcessMessage) {
		select {
		case messageChan <- msg:
		case <-ctx.Done():
		}
	}

	sendError := func(err ProcessError) {
		select {
		case errorChan <- err:
		case <-ctx.Done():
		}
	}

	sendMessage(ProcessMessage{"", "Starting to process all repositories"})

	// Sort clone URLs alphabetically
	sort.Strings(cloneURLs)

	for _, repoURL := range cloneURLs {
		select {
		case <-ctx.Done():
			sendMessage(ProcessMessage{"", "Processing canceled"})
			return
		default:
			sendMessage(ProcessMessage{repoURL, "Starting to process repository"})

			// Clone the repository into memory
			repo, err := git.CloneContext(
				ctx,
				memory.NewStorage(),
				nil,
				&git.CloneOptions{
					URL:   repoURL,
					Depth: depth,
				})
			if err != nil {
				if strings.Contains(err.Error(), "remote repository is empty") {
					doxlog.Warnf("Repository '%s' is empty", repoURL)
					continue
				}
				sendError(ProcessError{repoURL, fmt.Errorf("error cloning repository: %v", err)})
				sendMessage(ProcessMessage{repoURL, "Finished processing repository with error"})
				continue
			}

			// Get the HEAD reference
			ref, err := repo.Head()
			if err != nil {
				sendError(ProcessError{repoURL, fmt.Errorf("error getting HEAD: %v", err)})
				sendMessage(ProcessMessage{repoURL, "Finished processing repository with error"})
				continue
			}

			// Get the commit object
			commit, err := repo.CommitObject(ref.Hash())
			if err != nil {
				sendError(ProcessError{repoURL, fmt.Errorf("error getting commit object: %v", err)})
				sendMessage(ProcessMessage{repoURL, "Finished processing repository with error"})
				continue
			}

			// Get the tree for the commit
			tree, err := commit.Tree()
			if err != nil {
				sendError(ProcessError{repoURL, fmt.Errorf("error getting tree: %v", err)})
				sendMessage(ProcessMessage{repoURL, "Finished processing repository with error"})
				continue
			}

			// Collect and sort files
			var files []*object.File
			err = tree.Files().ForEach(func(file *object.File) error {
				if path.Ext(file.Name) == "."+fileExtension {
					files = append(files, file)
				}
				return nil
			})
			if err != nil {
				sendError(ProcessError{repoURL, fmt.Errorf("error collecting files: %v", err)})
				continue
			}

			// Sort files alphabetically based on their subpath and filename
			sort.Slice(files, func(i, j int) bool {
				return files[i].Name < files[j].Name
			})

			// Process sorted files
			for _, file := range files {
				select {
				case <-ctx.Done():
					return
				default:
					contents, err := file.Contents()
					if err != nil {
						sendError(ProcessError{repoURL, fmt.Errorf("error reading file %s: %v", file.Name, err)})
						continue
					}

					// Sort lines alphabetically
					lines := strings.Split(contents, "\n")
					sort.Strings(lines)

					// Process each sorted line of the file
					for _, line := range lines {
						if line != "" {
							select {
							case outputChan <- line:
							case <-ctx.Done():
								return
							}
						}
					}
				}
			}

			sendMessage(ProcessMessage{repoURL, "Finished processing repository successfully"})
		}
	}

	sendMessage(ProcessMessage{"", "Finished processing all repositories"})
}
func (g *Git) CloneWithAuth(path, url, username, password string, deleteFirst bool) (string, error) {
	dirPath, err := DirPath(path, url)
	if err != nil {
		return url, err
	}
	if deleteFirst {
		err = ltfile.DeleteDirRecursively(dirPath)
		if err != nil {
			return url, err
		}
	}
	_, err = git.PlainClone(dirPath, false, &git.CloneOptions{
		URL:      url,
		Progress: os.Stdout,
		Auth: &http.BasicAuth{
			Username: username,
			Password: password,
		},
	})
	return dirPath, err
}
func (g *Git) GetFileContent(url string, filename string) ([]byte, error) {
	fs := memfs.New()
	_, err := git.Clone(memory.NewStorage(), fs, &git.CloneOptions{
		URL: url,
	})
	if err != nil {
		return nil, err
	}
	f, err := fs.Open(filename)
	if err != nil {
		return nil, err
	}
	content, err := ioutil.ReadAll(f)
	if err != nil {
		return nil, err
	}
	return content, nil
}

// Init will initialize git in the dirPath and set the remote to the specified url.
// If the dirPath does not exist, it will be created.
func (g *Git) Init(dirPath string, url string) error {
	if !ltfile.DirExists(dirPath) {
		err := ltfile.CreateDirs(dirPath)
		if err != nil {
			return err
		}
	}
	fs := osfs.New(dirPath)
	dot, err := fs.Chroot(".git")
	if err != nil {
		return err
	}
	storage := filesystem.NewStorage(dot, cache.NewObjectLRUDefault())
	r, err := git.Init(storage, nil)
	if err != nil {
		return err
	}
	// AddPathToMap a new remote, with the default fetch refspec
	_, err = r.CreateRemote(&config.RemoteConfig{
		Name: DoxaOrigin,
		URLs: []string{url},
	})
	r.CreateBranch(&config.Branch{
		Name:   Master,
		Remote: DoxaOrigin,
	})
	return err
}
func (g *Git) CloneTo(dirPath string, url string, showProgress bool, deleteFirst bool) error {
	var err error
	if !ltfile.DirExists(dirPath) {
		err = ltfile.CreateDir(dirPath)
	}
	if deleteFirst {
		err = ltfile.DeleteDirRecursively(dirPath)
		if err != nil {
			return err
		}
	}
	if showProgress {
		_, err = git.PlainClone(dirPath, false, &git.CloneOptions{
			URL:      url,
			Progress: os.Stdout,
		})
	} else {
		_, err = git.PlainClone(dirPath, false, &git.CloneOptions{
			URL: url,
		})

	}
	return err
}

// CloneLiml clones the liml site into toDir and removes the .git folder, .gitignore, etc.
func (g *Git) CloneLiml(toDir string, verbose bool) error {
	theUrl := "https://gitlab.com/ocmc/liml/site.git"
	if verbose {
		fmt.Printf("Cloning liml site into %s", toDir)
	}
	err := g.CloneTo(toDir, theUrl, verbose, true)
	if err != nil {
		return err
	}
	_ = ltfile.DeleteDirRecursively(path.Join(toDir, ".git"))
	_ = ltfile.DeleteFile(path.Join(toDir, ".gitignore"))
	_ = ltfile.DeleteFile(path.Join(toDir, ".gitlab-ci.yml"))
	if verbose {
		fmt.Printf("Finished cloning demo")
	}
	return err
}

// ClearAllInRepo performs a git rm on all files and directories (recursively), leaving only .git.  It then pushes the changes to doxa-origin.
func (g *Git) ClearAllInRepo(dirPath, username, password string) error {
	entries, err := ltfile.EntriesInDir(dirPath)
	if err != nil {
		return fmt.Errorf("error listing files and dirs in %s: %v", dirPath, err)
	}
	for _, entry := range entries {
		if strings.HasPrefix(entry.Name(), ".git") {
			continue
		}
		if entry.IsDir() {
			fmt.Printf("simulated DIR delete: %s\n", path.Join(dirPath, entry.Name()))
		} else {
			fmt.Printf("simulated FIL delete: %s\n", path.Join(dirPath, entry.Name()))
		}
	}
	return nil
}

// ClearAllRepos calls ClearAllInRepo for each git repo found as subdirectories in targetPath
func (g *Git) ClearAllRepos(targetPath, username, password string) error {
	repos, err := g.FindRepos(targetPath)
	if err != nil {
		return err
	}
	for _, repo := range repos {
		err := g.ClearAllInRepo(repo, username, password)
		if err != nil {
			return err
		}
	}
	return nil
}

// Commit adds and commits a specific file
func (g *Git) Commit(relativeFileName, msg string) error {
	if strings.HasPrefix(relativeFileName, g.LocalRepoPath) {
		relativeFileName = strings.TrimPrefix(relativeFileName, g.LocalRepoPath)[1:]
	}
	r, err := git.PlainOpen(g.LocalRepoPath)
	if err != nil {
		return err
	}
	w, err := r.Worktree()
	if err != nil {
		return err
	}
	_, err = w.Add(relativeFileName)
	if err != nil {
		return err
	}
	_, err = w.Commit(msg, &git.CommitOptions{
		Author: &object.Signature{
			Name:  "doxa",
			Email: "doxa@ocmc.org",
			When:  time.Now(),
		},
	})
	return err
}
func (g *Git) CommitAll(dirPath, message string) error {
	_, err := g.CommitAllWithHash(dirPath, message)
	return err
}

func (g *Git) CommitAllWithHash(dirPath, message string) (string, error) {
	// Opens an already existing repository.
	r, err := git.PlainOpen(dirPath)
	if err != nil {
		return "", err
	}
	w, err := r.Worktree()
	if err != nil {
		return "", err
	}
	// add everything,including supposedly deletes, but there is a bug
	err = w.AddWithOptions(&git.AddOptions{
		All: true,
	})
	if err != nil {
		return "", err
	}
	//// workaround for All not including deleted files
	status, err := w.Status()
	if err != nil {
		return "", err
	}
	for file, s := range status {
		if s.Worktree == git.Deleted {
			_, err = w.Add(file)
			if err != nil {
				return "", err
			}
		}
	}
	hash, err := w.Commit(message, &git.CommitOptions{
		All: true,
		Author: &object.Signature{
			Name:  "doxa",
			Email: "doxa@ocmc.org",
			When:  time.Now(),
		},
	})
	if err != nil {
		return hash.String(), err
	}
	return hash.String(), nil
}

func (g *Git) CreateRemote(path, url string) error {
	r, err := git.PlainOpen(path)
	if err != nil {
		return err
	}
	c := new(config.RemoteConfig)
	c.Name = DoxaOrigin
	c.URLs = append(c.URLs, url)
	remote, err := r.CreateRemote(c)
	if err != nil {
		return err
	}
	if remote != nil {

	}
	return nil
}

// FilesToProcess add files of all types except for .git dir and its contents.
// TODO: add filter from gitignore file in root dir
func (g *Git) FilesToProcess(dirPath string) []string {
	var files []string
	filepath.Walk(ltfile.ToSysPath(dirPath),
		func(path string, info os.FileInfo, err error) error {
			path = ltfile.ToUnixPath(path)
			if err != nil {
				return err
			}
			if strings.Contains(path, "/.git/") {
				return nil
			}
			if !info.IsDir() {
				files = append(files, info.Name())
			}
			return nil
		})
	return files
}

// FindRepos returns the path for each git repo found as immediate child subdirectories in targetPath
func (g *Git) FindRepos(targetPath string) ([]string, error) {
	var repos []string
	entries, err := ltfile.EntriesInDir(targetPath)
	if err != nil {
		return nil, fmt.Errorf("error listing files and dirs in %s: %v", targetPath, err)
	}
	for _, entry := range entries {
		if entry.Name() == ".DS_Store" {
			continue
		}
		if entry.IsDir() {
			if entry.Name() == ".git" {
				repos = append(repos, fmt.Sprintf(targetPath))
			} else {
				subRepos, err := g.FindRepos(path.Join(targetPath, entry.Name()))
				if err != nil {
					return nil, fmt.Errorf("error listing files and dirs in %s: %v", targetPath, err)
				}
				if len(subRepos) > 0 {
					repos = append(repos, subRepos...)
				}
			}
		}
	}
	return repos, nil
}

// LocalAndOriginDiffer compares the hash of master to that of origin and returns the changes.
// See DiffStatus for information returned
// If an error occurs, DiffStatus will not be null.
func (g *Git) LocalAndOriginDiffer() (*DiffStatus, error) {
	diffStatus := new(DiffStatus)
	r, err := git.PlainOpen(g.LocalRepoPath)
	if err != nil {
		diffStatus.DiffMessage = fmt.Sprintf("could not open local repo %s: %v", g.LocalRepoPath, err)
		return diffStatus, err
	}
	remotes, err := r.Remotes()
	if err != nil {
		diffStatus.DiffMessage = fmt.Sprintf("could not get remotes for local repo %s: %v", g.LocalRepoPath, err)
		return diffStatus, err
	}
	theUrl := remotes[0].Config().URLs[0]
	err = r.Fetch(&git.FetchOptions{
		RemoteName: DoxaOrigin,
	})
	if err != nil {
		if fmt.Sprintf("%s", err) != "already up-to-date" {
			diffStatus.Differ = false
			diffStatus.DiffMessage = fmt.Sprintf("local repo %s up-to-date with remote %s", g.LocalRepoPath, theUrl)
			return diffStatus, nil
			//} else {
			//	diffStatus.DiffMessage = fmt.Sprintf("could not fetch %s: %v", url, err)
			//	return diffStatus, err
		}
	}
	localRevHash, err := r.ResolveRevision("HEAD")
	if err != nil {
		diffStatus.DiffMessage = fmt.Sprintf("could not get resolve HEAD for local repo %s: %v", g.LocalRepoPath, err)
		return diffStatus, err
	}
	revStr := fmt.Sprintf("refs/remotes/%s/%s", DoxaOrigin, Master)
	originRevHash, err := r.ResolveRevision(plumbing.Revision(revStr))
	if err != nil {
		diffStatus.DiffMessage = fmt.Sprintf("could not resolve %s for remote %s: %v", revStr, theUrl, err)
		return diffStatus, err
	}
	if localRevHash.String() == originRevHash.String() {
		diffStatus.DiffMessage = fmt.Sprintf("remote %s and local %s are the same", theUrl, g.LocalRepoPath)
		return diffStatus, nil
	} else {
		diffStatus.Differ = true
	}
	originRevCommit, err := r.CommitObject(*originRevHash)
	if err != nil {
		diffStatus.DiffMessage = fmt.Sprintf("could not get commit for remote %s: %v", theUrl, err)
		return diffStatus, err
	}
	localRevCommit, err := r.CommitObject(*localRevHash)
	if err != nil {
		diffStatus.DiffMessage = fmt.Sprintf("could not get commit for local repo %s: %v", g.LocalRepoPath, err)
		return diffStatus, err
	}
	t1, _ := originRevCommit.Tree()
	t2, _ := localRevCommit.Tree()
	var changes object.Changes
	changes, err = t1.Diff(t2)
	if err != nil {
		diffStatus.DiffMessage = fmt.Sprintf("error comparing remote %s and local %s: %v", theUrl, g.LocalRepoPath, err)
		return diffStatus, nil
	}
	patch, err := changes.Patch()
	if err != nil {
		diffStatus.DiffMessage = fmt.Sprintf("error getting patch for remote %s and local %s: %v", theUrl, g.LocalRepoPath, err)
		return diffStatus, nil
	}
	isAncestor, err := originRevCommit.IsAncestor(localRevCommit)
	diffStatus = NewDiffStatus(!isAncestor,
		theUrl,
		g.LocalRepoPath,
		patch.String(),
		originRevCommit,
		localRevCommit,
	)
	return diffStatus, nil
}

// LocalExists returns true if there is a git repo initialized in the specified directory
func (g *Git) LocalExists(dirPath string) bool {
	return ltfile.DirExists(path.Join(dirPath, ".git"))
}
func (g *Git) Pull(repoPath, origin string, force bool) (gitStatuses.GitStatus, error) {
	//	var hash plumbing.Hash
	r, err := git.PlainOpen(repoPath)
	if err != nil {
		return gitStatuses.TypeForError(err), err
	}
	// GetKeyPath the working directory for the repository
	w, err := r.Worktree()
	if err != nil {
		return gitStatuses.TypeForError(err), err
	}
	// PullDoxa the latest changes from the origin remote and merge into the current branch
	err = w.Pull(&git.PullOptions{
		RemoteName:    origin,
		ReferenceName: plumbing.ReferenceName("refs/heads/main"),
		Force:         force,
	})
	if err != nil {
		errStr := fmt.Sprintf("%v", err)
		return gitStatuses.CodeForString(errStr), err
	}
	return gitStatuses.Success, nil
}
func (g *Git) PullDoxa(repoPath string, force bool) (gitStatuses.GitStatus, error) {
	return g.Pull(repoPath, DoxaOrigin, force)
}
func (g *Git) PullOrigin(repoPath string, force bool) (gitStatuses.GitStatus, error) {
	return g.Pull(repoPath, DefaultOrigin, force)
}

func (g *Git) PullWithAuth(repoPath, origin, username, password string, force bool) (gitStatuses.GitStatus, error) {
	//	var hash plumbing.Hash
	r, err := git.PlainOpen(repoPath)
	if err != nil {
		return gitStatuses.TypeForError(err), err
	}
	// GetKeyPath the working directory for the repository
	w, err := r.Worktree()
	if err != nil {
		return gitStatuses.TypeForError(err), err
	}
	// PullDoxa the latest changes from the origin remote and merge into the current branch
	err = w.Pull(&git.PullOptions{
		RemoteName: origin,
		Force:      force,
		Auth: &http.BasicAuth{
			Username: username,
			Password: password,
		},
	})
	if err != nil {
		errStr := fmt.Sprintf("%v", err)
		return gitStatuses.CodeForString(errStr), err
	}
	return gitStatuses.Success, nil
}

// Move moves a file or a directory from oldPath to newPath in the repository
func (g *Git) Move(oldPath, newPath, msg string, fileSystemAlso bool) error {
	// Open an existing repository
	r, err := git.PlainOpen(g.LocalRepoPath)
	if err != nil {
		return err
	}

	// Get the working directory for the repository
	w, err := r.Worktree()
	if err != nil {
		return err
	}

	if fileSystemAlso {
		// Rename (move) the file or directory in the file system
		err = ltfile.RenameDir(g.LocalRepoPath+"/"+oldPath, g.LocalRepoPath+"/"+newPath)
		if err != nil {
			return err
		}
	}

	// Stage the move operation for the next commit
	_, err = w.Add(newPath)
	if err != nil {
		return err
	}

	// Commit the changes
	_, err = w.Commit(msg, &git.CommitOptions{
		Author: &object.Signature{
			Name:  "Your name",              // Replace with your name
			Email: "your.email@example.com", // Replace with your email
			When:  time.Now(),
		},
	})

	return err
}

// Remove does a git rm and commit.  If fileSystemAlso == true, calls os to delete as well.
func (g *Git) Remove(relativePath, msg string, fileSystemAlso bool) error {

	// Open the repository
	r, err := git.PlainOpen(g.LocalRepoPath)
	if err != nil {
		return err
	}

	// Get the working directory for the repository
	w, err := r.Worktree()
	if err != nil {
		return err
	}

	if fileSystemAlso {
		// Delete the file or directory from the file system
		err = ltfile.DeleteDirRecursively(g.LocalRepoPath + "/" + relativePath)
		if err != nil {
			return err
		}
	}

	// Stage the removed file or directory for the next commit
	_, err = w.Remove(relativePath)
	if err != nil {
		return err
	}

	// Commit the changes
	_, err = w.Commit(msg, &git.CommitOptions{
		Author: &object.Signature{
			Name:  "doxa",
			Email: "doxa@ocmc.org",
			When:  time.Now(),
		},
	})

	return err
}

// Usage of Git.Remove remains the same
type RepoProxy struct {
	Repo         *git.Repository
	Path         string
	Config       *config.Config
	RemoteOrigin string // fetch and push url
	RemoteDoxa   string // fetch and push url
}

// NewRepoProxy returns a proxy with the remote doxa-origin set.
func NewRepoProxy(dirPath string) (proxy *RepoProxy, err error) {
	proxy = new(RepoProxy)
	proxy.Path = dirPath
	proxy.Repo, err = git.PlainOpen(dirPath)
	if err != nil {
		return nil, err
	}
	proxy.Config, err = proxy.Repo.Config()
	if err != nil {
		return proxy, &GitConfigMissingError{
			err:  "config not found",
			path: proxy.Path,
		}
	}
	if proxy.Config != nil {
		if len(proxy.Config.Remotes) == 0 {
			return proxy, &GitRemoteMissingError{
				err:  "remotes not set",
				path: proxy.Path,
			}
		}
		for k, v := range proxy.Config.Remotes {
			if k == DoxaOrigin {
				if len(v.URLs) > 0 {
					proxy.RemoteDoxa = v.URLs[0]
				}
			} else {
				// we expect a default remote, e.g. origin, to have an url
				if len(v.URLs) == 0 {
					return proxy, &GitRemoteUrlMissingError{
						err:  fmt.Sprintf("no urls for remote in config"),
						path: dirPath,
					}
				}
				proxy.RemoteOrigin = v.URLs[0]
			}
		}
		// if doxa-origin not set, set it
		if len(proxy.RemoteDoxa) == 0 {
			proxy.RemoteDoxa, err = SshUrlToHttps(proxy.RemoteOrigin)
			if err != nil {
				return proxy, fmt.Errorf("error converting ssh url %s to https url: %v", proxy.RemoteOrigin, err)
			}
			_, err = proxy.Repo.CreateRemote(&config.RemoteConfig{
				Name: DoxaOrigin,
				URLs: []string{proxy.RemoteDoxa},
			})
		}
	}
	return proxy, err
}
func (g *Git) Push(dirPath, username, password string) error {
	pr, err := NewRepoProxy(dirPath)
	if err != nil {
		return err
	}
	err = pr.Repo.Push(&git.PushOptions{
		Auth: &http.BasicAuth{
			Username: username,
			Password: password,
		},
		RemoteName: DoxaOrigin,
	})
	return err
}

// RemoteUrl reads the local repository specified by path and returns the first remote url for origin.
// If the path endpoint is not a git repository, an error is returned.
func (g *Git) RemoteUrl(path string) (string, error) {
	var remote = DoxaOrigin
	var remoteUrl string
	r, err := git.PlainOpen(path)
	if err != nil {
		return "", &GitRepoMissingError{
			err:  "not a git repo",
			path: path,
		}
	}
	config, err := r.Config()
	if err != nil {
		return "", &GitConfigMissingError{
			err:  "config not found",
			path: path,
		}
	}
	if config != nil {
		if _, ok := config.Remotes[remote]; !ok {
			return "", &GitRemoteMissingError{
				err:  fmt.Sprintf("remote %s missing in config", remote),
				path: path,
			}
		}
		if len(config.Remotes[remote].URLs) == 0 {
			return "", &GitRemoteUrlMissingError{
				err:  fmt.Sprintf("no urls for remote %s in config", remote),
				path: path,
			}
		}
		remoteUrl = config.Remotes[remote].URLs[0]
	}
	return remoteUrl, nil
}
func (g *Git) SetPath(repoPath string) {
	g.LocalRepoPath = repoPath
}
func (g *Git) ModifiedFiles(repoPath string) (string, error) {
	repo, err := git.PlainOpen(repoPath)
	if err != nil {
		return "", err
	}
	w, _ := repo.Worktree()
	var status git.Status
	status, err = w.Status()
	if err != nil {
		return "", err
	}
	return status.String(), nil
}

// UpToDate returns true if result of git fetch indicates no difference
// and there are no uncommitted file changes.
func (g *Git) UpToDate(path string) (bool, error) {
	var noModifiedFiles bool
	var localAndRemoteHeadSame bool

	r, err := git.PlainOpen(path)
	if err != nil {
		return false, err
	}
	err = r.Fetch(&git.FetchOptions{
		RemoteName: DoxaOrigin,
	})
	if err != nil {
		msg := fmt.Sprintf("%s", err)
		if strings.Contains(msg, "up-to-date") {
			localAndRemoteHeadSame = true
		}
	}
	modifiedFiles, err := g.ModifiedFiles(path)
	if err != nil {
		return false, err
	}
	noModifiedFiles = len(modifiedFiles) == 0
	return noModifiedFiles && localAndRemoteHeadSame, nil
}

// UserAuthorized opens the specified local repository
// and attempts a remote fetch
// using the uid and pwd for authentication.
// If the path is bad, an error is returned.
// If the user is not authorized for the requested repository, false and nil are returned.
func (g *Git) UserAuthorized(path string, uid string, pwd string) (bool, error) {
	auth := new(http.BasicAuth)
	auth.Username = uid
	auth.Password = pwd
	repo, err := git.PlainOpen(path)
	if err != nil {
		return false, err
	}
	_ = repo.Fetch(&git.FetchOptions{
		Auth:       auth,
		RemoteName: DoxaOrigin,
	})
	if err == nil {
		return true, nil
	}
	msg := fmt.Sprintf("%s", err)
	if strings.Contains(msg, "authentication") {
		return false, nil
	} else {
		return false, err
	}
}

// CheckoutOptions is used in conjunction with Checkout
// it differs from go-git in that Create, Hash, and Branch are not present
type CheckoutOptions struct {
	Force bool
	Keep  bool
}

// Checkout switches branches
// options can be nil, but may lead to errors in the case of conflicts
func (g *Git) Checkout(repoPath, branch string, options *CheckoutOptions) error {
	if options == nil {
		options = &CheckoutOptions{
			Force: false,
			Keep:  false,
		}
	}

	r, err := git.PlainOpen(repoPath)
	if err != nil {
		doxlog.Errorf("could not open repository: %v", err)
		return err
	}
	w, err := r.Worktree()
	if err != nil {
		doxlog.Errorf("error accessing working tree: %v", err)
		return err
	}
	opts := new(git.CheckoutOptions)
	opts.Branch = plumbing.NewBranchReferenceName(branch)
	opts.Create = false
	opts.Keep = options.Keep
	opts.Force = options.Force
	err = w.Checkout(opts)
	if err != nil {
		doxlog.Errorf("problem at checkout: %v", err)
	}
	return nil
}

type CommitInfo struct {
	Designator    string // a or b
	Path          string // url or local repo path
	AuthorName    string
	AuthorEmail   string
	AuthorMessage string
	AuthorTime    time.Time
}

func NewCommitInfo(designator, path string, commit *object.Commit) *CommitInfo {
	c := new(CommitInfo)
	c.AuthorName = commit.Author.Name
	c.AuthorEmail = commit.Author.Email
	c.AuthorMessage = commit.Message
	c.AuthorTime = commit.Author.When
	c.Designator = fmt.Sprintf("%s/", designator)
	c.Path = path
	return c
}

type DiffStatus struct {
	Differ        bool
	Rev1AheadRev2 bool
	Rev2AheadRev1 bool
	Revision1     *CommitInfo
	Revision2     *CommitInfo
	Diffs         []string
	DiffMessage   string
}

func NewDiffStatus(aIsAheadB bool, rPath, lPath, diffs string, remote, local *object.Commit) *DiffStatus {
	d := new(DiffStatus)
	d.Revision1 = NewCommitInfo("a", rPath, remote)
	d.Revision2 = NewCommitInfo("b", lPath, local)
	if len(diffs) == 0 {
		d.Differ = false
		return d
	}
	d.Differ = true
	parts := strings.Split(diffs, "\n")
	var diffParts []string
	diffParts = append(diffParts, "Differences are shown file by file.")
	diffParts = append(diffParts, fmt.Sprintf("a/ is file on remote %s", rPath))
	diffParts = append(diffParts, fmt.Sprintf("b/ is in local %s", lPath))
	diffParts = append(diffParts, parts...)
	d.Diffs = diffParts
	if aIsAheadB {
		d.Rev1AheadRev2 = true
	} else {
		d.Rev2AheadRev1 = true
	}
	return d
}

type GitRepoMissingError struct {
	err  string
	path string
}

func (e *GitRepoMissingError) Error() string {
	return fmt.Sprintf("local git repo %s: %v", e.path, e.err)
}

type GitConfigMissingError struct {
	err  string
	path string
}

func (e *GitConfigMissingError) Error() string {
	return fmt.Sprintf("local git repo %s: %v", e.path, e.err)
}

type GitRemoteMissingError struct {
	err  string
	path string
}

func (e *GitRemoteMissingError) Error() string {
	return fmt.Sprintf("local git repo %s: %v", e.path, e.err)
}

type GitRemoteUrlMissingError struct {
	err  string
	path string
}

func (e *GitRemoteUrlMissingError) Error() string {
	return fmt.Sprintf("local git repo %s: %v", e.path, e.err)
}

func TokenError(token, base string) error {
	gl, err := gitlab.NewClient(token, gitlab.WithBaseURL(base))
	if err != nil {
		return err
	}

	_, _, err = gl.Version.GetVersion()
	return err
}
